import { ChangeDetectionStrategy, Component } from '@angular/core';
import { FaIconComponent } from '@fortawesome/angular-fontawesome';
import { ContainerComponent, PopoverDirective, RowComponent } from '@coreui/angular';
import { TranslocoDirective } from '@jsverse/transloco';
import { NgClass } from '@angular/common';

@Component({
    selector: 'oitc-regex-helper-tooltip',
    imports: [
        FaIconComponent,
        PopoverDirective,
        TranslocoDirective,
        RowComponent,
        ContainerComponent,
        NgClass
    ],
    templateUrl: './regex-helper-tooltip.component.html',
    styleUrl: './regex-helper-tooltip.component.css',
    changeDetection: ChangeDetectionStrategy.OnPush
    // encapsulation: ViewEncapsulation.Emulated,
})
export class RegexHelperTooltipComponent {
    public light: boolean = false

    // triggered by mouseover event - no manual change detection required
    lightSwitch() {
        this.light = !this.light;
    }

}
