import { PaginateOrScroll } from '../../../../layouts/coreui/paginator/paginator.interface';
import { Container } from '../../../../containers.interface';

export interface MapsIndexRoot extends PaginateOrScroll {
    all_maps: Map[]
    _csrfToken: string
}

/*******************************
 *    Definition of Map        *
 ******************************/

export interface Map {
    id: number
    name: string
    title: string
    object_id?: number
    background?: string | null
    background_x?: number | null
    background_y?: number | null
    background_size_x?: number | null
    background_size_y?: number | null
    refresh_interval?: number
    json_data?: string
    created?: string
    modified?: string
    containers?: MapContainer[]
    allowEdit?: boolean
    allowCopy?: boolean
    _joinData?: MapRotationJoinData
}

export interface MapRotationJoinData {
    id: number
    map_id: number
    rotation_id: number
}

export interface MapContainer extends Container {
    _joinData: MapContainerJoinData
}

export interface MapContainerJoinData {
    id: number
    container_id: number
    map_id: number
}


export interface MapsIndexParams {
    // Same again? Maybe create an intermediate class? OOP FTW :-P
    angular: true,
    scroll: boolean,
    sort: string,
    page: number,
    direction: 'asc' | 'desc' | '', // asc or desc
    'filter[Maps.name]': string,
    'filter[Maps.title]': string,
}

export function getDefaultMapsIndexParams(): MapsIndexParams {
    return {
        angular: true,
        scroll: false,
        sort: 'Maps.name',
        page: 1,
        direction: 'asc',
        'filter[Maps.name]': "",
        'filter[Maps.title]': "",
    }
}
