import { inject, Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { PROXY_PATH } from '../../../tokens/proxy-path.token';
import { map, Observable } from 'rxjs';
import { DashboardsIndexRoot } from '../dashboards.interface';

@Injectable({
    providedIn: 'root'
})
export class DashboardsService {
    private readonly http: HttpClient = inject(HttpClient);
    private readonly proxyPath: string = inject(PROXY_PATH);

    public getIndex(): Observable<DashboardsIndexRoot> {
        const proxyPath = this.proxyPath;

        return this.http.get<DashboardsIndexRoot>(`${proxyPath}/Dashboard/index.json`).pipe(
            map(data => {
                return data;
            })
        );
    }

}
