export interface DashboardsIndexRoot {
    hostCount: number
    serviceCount: number
    hostSummaryState: HostSummaryState
    serviceSummaryState: ServiceSummaryState
    hostStatusCounts: {
        state: HostStatusCount
        acknowledged: HostStatusCount
        in_downtime: HostStatusCount
        not_handled: HostStatusCount
        passive: HostStatusCount
    }
    serviceStatusCounts: {
        state: ServiceStatusCount
        acknowledged: ServiceStatusCount
        in_downtime: ServiceStatusCount
        not_handled: ServiceStatusCount
        passive: ServiceStatusCount
    }
}

export interface HostStatusCount {
    0: number, // up
    1: number, // down
    2: number, // unreachable
}

export interface ServiceStatusCount {
    0: number, // ok
    1: number, // warning
    2: number, // critical
    3: number, // unknown
}

export interface HostSummaryState {
    up: number
    down: number
    unreachable: number
}

export interface ServiceSummaryState {
    ok: number
    warning: number
    critical: number
    unknown: number
}
