import { inject, Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { PROXY_PATH } from '../../tokens/proxy-path.token';
import { HostsBrowserRoot, HostsIndexParams, HostsIndexRoot } from './hosts.interface';
import { map, Observable } from 'rxjs';

@Injectable({
    providedIn: 'root'
})
export class HostsService {
    private readonly http = inject(HttpClient);
    private readonly proxyPath = inject(PROXY_PATH);

    constructor() {
    }

    public getIndex(params: HostsIndexParams): Observable<HostsIndexRoot> {
        const proxyPath = this.proxyPath;

        return this.http.get<HostsIndexRoot>(`${proxyPath}/hosts/index.json`, {
            params: params as {}
        }).pipe(
            map(data => {
                return data;
            })
        );
    }

    public getHostBrowser(hostUuid: string): Observable<HostsBrowserRoot> {
        const proxyPath = this.proxyPath;

        return this.http.get<HostsBrowserRoot>(`${proxyPath}/hosts/browser.json`, {
            params: {
                uuid: hostUuid
            }
        }).pipe(
            map(data => {
                return data;
            })
        );
    }

}
