import { PaginateOrScroll } from '../../layouts/coreui/paginator/paginator.interface';

/**********************
 *    Host action    *
 **********************/
export interface StatehistoryHostParams {
    angular: true,
    scroll: boolean,
    sort: string,
    page: number,
    direction: 'asc' | 'desc' | '', // asc or desc
    'filter[HostStatehistory.hostname]': string, // uuid
    'filter[HostStatehistory.output]': string,
    'filter[HostStatehistory.state][]': string[],
    'filter[HostStatehistory.is_hardstate]': string | number
}

export function getDefaultStatehistoryHostParams(): StatehistoryHostParams {
    return {
        angular: true,
        scroll: true,
        sort: 'state_time',
        page: 1,
        direction: 'desc',
        'filter[HostStatehistory.hostname]': '',
        'filter[HostStatehistory.output]': '',
        'filter[HostStatehistory.state][]': [],
        'filter[HostStatehistory.is_hardstate]': ''
    }
}

export interface StatehistoriesHostRoot extends PaginateOrScroll {
    hoststatehistory: StatehistoryHost[]
}

export interface StatehistoryHost {
    hostname: string
    state_time: string
    state_time_usec: number
    state_change: boolean
    state: number
    is_hardstate: boolean
    current_check_attempt: number
    max_check_attempts: number
    last_state: number
    last_hard_state: number
    output: string
    long_output: string
}

/**********************
 *    Service action    *
 **********************/
export interface StatehistoryServiceParams {
    angular: true,
    scroll: boolean,
    sort: string,
    page: number,
    direction: 'asc' | 'desc' | '', // asc or desc
    'filter[ServiceStatehistory.service_description]': string, // uuid
    'filter[ServiceStatehistory.output]': string,
    'filter[ServiceStatehistory.state][]': string[],
    'filter[ServiceStatehistory.is_hardstate]': string | number
}

export function getDefaultStatehistoryServiceParams(): StatehistoryServiceParams {
    return {
        angular: true,
        scroll: true,
        sort: 'ServiceStatehistory.state_time',
        page: 1,
        direction: 'desc',
        'filter[ServiceStatehistory.service_description]': '',
        'filter[ServiceStatehistory.output]': '',
        'filter[ServiceStatehistory.state][]': [],
        'filter[ServiceStatehistory.is_hardstate]': '',
    }
}

export interface StatehistoriesServiceRoot extends PaginateOrScroll {
    servicestatehistory: StatehistoryService[],
    hostUuid: string
}

export interface StatehistoryService {
    service_description: string
    state_time: string
    state_time_usec: number
    hostname: string
    state_change: boolean
    state: number
    is_hardstate: boolean
    current_check_attempt: number
    max_check_attempts: number
    last_state: number
    last_hard_state: number
    output: string
    long_output: string
}
