import { Pipe, PipeTransform } from '@angular/core';

@Pipe({
    name: 'filter',
    standalone: true
})
export class FilterPipe implements PipeTransform {

    transform(values: any[], filter: { [key: string]: any }): any[] {
        if (!values || !filter) {
            return values;
        }
        return values.filter(outage => this.matchesFilter(outage, filter));
    }

    private matchesFilter(outage: any, filter: { [key: string]: any }): boolean {
        for (let key in filter) {
            if (outage[key] !== filter[key]) {
                return false;
            }
        }
        return true;
    }

}
